#include "FrameInfo.h"

#ifndef _VIDEO_DECODE_SDK_H_
#define _VIDEO_DECODE_SDK_H_

/************************************************************************
ýģö߳̽룬CPUԶͬĿḶ̌߳Դ
CPUԴн
/************************************************************************/

#define CALL_METHOD __stdcall

#ifdef VIDEO_DECODE_SDK_EXPORTS
#define DECODE_API __declspec(dllexport)
#else
//#define DECODE_API __declspec(dllimport)
#define DECODE_API
#endif

enum VIDEO_DECODE_RET
{
	DECODE_RET_SUCCESS,
	DECODE_RET_NOT_START,
	DECODE_RET_BUSY,
};


#ifdef __cplusplus
extern "C"
{
#endif

typedef void (CALL_METHOD *DecDataCallbackFun)(int threadID, int deviceID, unsigned short channel, int streamType, DECODE_FRAME_INFO frameData, void *pUser);

//ʼΪԴ
DECODE_API BOOL CALL_METHOD DECODE_Initial();

//˳ͷŽԴ
DECODE_API void CALL_METHOD DECODE_Quit();

//ĳͨĽ
DECODE_API BOOL CALL_METHOD DECODE_Start(int deviceID, int channel, int streamType);

//ָֹͣͨĽ
DECODE_API void CALL_METHOD DECODE_Stop(int deviceID, int channel, int streamType);

//ָͨƵʽ
DECODE_API BOOL CALL_METHOD DECODE_SetVideoFormat(int deviceID, int channel, int streamType, BITMAPINFOHEADER bmpInfoHeader);

//ȡָͨĸʽ
DECODE_API BOOL CALL_METHOD DECODE_GetDecVideoFormat(int deviceID, int channel, int streamType, BITMAPINFOHEADER *pBmpInfoHeader);

//ýǷΪYUV(0ǣ1)
DECODE_API void CALL_METHOD DECODE_SetDecVideoFormat(BOOL enbaleYUV);

//һ֡ݣؽVIDEO_DECODE_RET
DECODE_API LONG CALL_METHOD DECODE_DecodeOneFrame(int deviceID, int channel, int streamType, ENCODE_FRAME_INFO encodeFrame);

//ýݻص
DECODE_API BOOL CALL_METHOD DECODE_SetDecDataCallback(int deviceID, int channel, int streamType, DecDataCallbackFun fDecCBFun, void *pParam);

DECODE_API BOOL CALL_METHOD DECODE_CapturePictureJPEG(DWORD &dwPicSize,int deviceID,DWORD dwChannel,int streamType, BYTE *pUserBuf,DWORD dwUserSize);


#ifdef __cplusplus
};
#endif

#endif
